/**
* World Storage API
* API ensuring interoperability between an authoring tool and a World Storage service
*
* The version of the OpenAPI document: 0.0.1
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/
/*
 * TrackablesApi.h
 *
 * 
 */

#ifndef TrackablesApi_H_
#define TrackablesApi_H_


#include <pistache/http.h>
#include <pistache/router.h>
#include <pistache/http_headers.h>

#include <optional>
#include <utility>

#include "Error.h"
#include "Trackable.h"
#include <string>

namespace org::openapitools::server::api
{

class  TrackablesApi {
public:
    explicit TrackablesApi(const std::shared_ptr<Pistache::Rest::Router>& rtr);
    virtual ~TrackablesApi() = default;
    void init();

    static const std::string base;

private:
    void setupRoutes();

    void add_trackable_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);
    void delete_trackable_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);
    void get_trackable_by_id_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);
    void get_trackables_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);
    void trackables_api_default_handler(const Pistache::Rest::Request &request, Pistache::Http::ResponseWriter response);

    const std::shared_ptr<Pistache::Rest::Router> router;

    /// <summary>
    /// Helper function to handle unexpected Exceptions during Parameter parsing and validation.
    /// May be overridden to return custom error formats. This is called inside a catch block.
    /// Important: When overriding, do not call `throw ex;`, but instead use `throw;`.
    /// </summary>
    virtual std::pair<Pistache::Http::Code, std::string> handleParsingException(const std::exception& ex) const noexcept;

    /// <summary>
    /// Helper function to handle unexpected Exceptions during processing of the request in handler functions.
    /// May be overridden to return custom error formats. This is called inside a catch block.
    /// Important: When overriding, do not call `throw ex;`, but instead use `throw;`.
    /// </summary>
    virtual std::pair<Pistache::Http::Code, std::string> handleOperationException(const std::exception& ex) const noexcept;

    /// <summary>
    /// Create a trackable
    /// </summary>
    /// <remarks>
    /// 
    /// </remarks>
    /// <param name="trackable">the trackable to be added to the world storage</param>
    virtual void add_trackable(const org::openapitools::server::model::Trackable &trackable, Pistache::Http::ResponseWriter &response) = 0;
    /// <summary>
    /// Deletes a trackable
    /// </summary>
    /// <remarks>
    /// 
    /// </remarks>
    /// <param name="trackableId">trackable id to delete</param>
    virtual void delete_trackable(const std::string &trackableId, Pistache::Http::ResponseWriter &response) = 0;
    /// <summary>
    /// Find a trackable by his ID
    /// </summary>
    /// <remarks>
    /// 
    /// </remarks>
    /// <param name="trackableId">ID of the trackable to retrieve</param>
    virtual void get_trackable_by_id(const std::string &trackableId, Pistache::Http::ResponseWriter &response) = 0;
    /// <summary>
    /// returns the list of all trackables defined by the world storage.
    /// </summary>
    /// <remarks>
    /// 
    /// </remarks>
    virtual void get_trackables(Pistache::Http::ResponseWriter &response) = 0;

};

} // namespace org::openapitools::server::api

#endif /* TrackablesApi_H_ */

