/**
* World Storage API
* API ensuring interoperability between an authoring tool and a World Storage service
*
* The version of the OpenAPI document: 0.0.1
* 
*
* NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
* https://openapi-generator.tech
* Do not edit the class manually.
*/


#include "Trackable.h"
#include "Helpers.h"

#include <sstream>

namespace org::openapitools::server::model
{

Trackable::Trackable()
{
    m_CreatorUID = "";
    m_TrackableType = "";
    m_TrackablePayload = "";
    m_UnitSystem = "";
    
}

void Trackable::validate() const
{
    std::stringstream msg;
    if (!validate(msg))
    {
        throw org::openapitools::server::helpers::ValidationException(msg.str());
    }
}

bool Trackable::validate(std::stringstream& msg) const
{
    return validate(msg, "");
}

bool Trackable::validate(std::stringstream& msg, const std::string& pathPrefix) const
{
    bool success = true;
    const std::string _pathPrefix = pathPrefix.empty() ? "Trackable" : pathPrefix;

                             
    
    /* TrackableDimension */ {
        const std::vector<double>& value = m_TrackableDimension;
        const std::string currentValuePath = _pathPrefix + ".trackableDimension";
                
        
        { // Recursive validation of array elements
            const std::string oldValuePath = currentValuePath;
            int i = 0;
            for (const double& value : value)
            { 
                const std::string currentValuePath = oldValuePath + "[" + std::to_string(i) + "]";
                        
        
 
                i++;
            }
        }

    }
        
    return success;
}

bool Trackable::operator==(const Trackable& rhs) const
{
    return
    
    
    (getCreatorUID() == rhs.getCreatorUID())
     &&
    
    (getTrackableType() == rhs.getTrackableType())
     &&
    
    (getTrackableEncodingInformation() == rhs.getTrackableEncodingInformation())
     &&
    
    (getTrackablePayload() == rhs.getTrackablePayload())
     &&
    
    (getUnitSystem() == rhs.getUnitSystem())
     &&
    
    (getTrackableDimension() == rhs.getTrackableDimension())
     &&
    
    (getKeyvalueTagList() == rhs.getKeyvalueTagList())
    
    
    ;
}

bool Trackable::operator!=(const Trackable& rhs) const
{
    return !(*this == rhs);
}

void to_json(nlohmann::json& j, const Trackable& o)
{
    j = nlohmann::json();
    j["creatorUID"] = o.m_CreatorUID;
    j["trackableType"] = o.m_TrackableType;
    j["trackableEncodingInformation"] = o.m_TrackableEncodingInformation;
    j["trackablePayload"] = o.m_TrackablePayload;
    j["unitSystem"] = o.m_UnitSystem;
    j["trackableDimension"] = o.m_TrackableDimension;
    j["keyvalueTagList"] = o.m_KeyvalueTagList;
    
}

void from_json(const nlohmann::json& j, Trackable& o)
{
    j.at("creatorUID").get_to(o.m_CreatorUID);
    j.at("trackableType").get_to(o.m_TrackableType);
    j.at("trackableEncodingInformation").get_to(o.m_TrackableEncodingInformation);
    j.at("trackablePayload").get_to(o.m_TrackablePayload);
    j.at("unitSystem").get_to(o.m_UnitSystem);
    j.at("trackableDimension").get_to(o.m_TrackableDimension);
    j.at("keyvalueTagList").get_to(o.m_KeyvalueTagList);
    
}

std::string Trackable::getCreatorUID() const
{
    return m_CreatorUID;
}
void Trackable::setCreatorUID(std::string const& value)
{
    m_CreatorUID = value;
}
std::string Trackable::getTrackableType() const
{
    return m_TrackableType;
}
void Trackable::setTrackableType(std::string const& value)
{
    m_TrackableType = value;
}
TrackableEncodingInformationStructure Trackable::getTrackableEncodingInformation() const
{
    return m_TrackableEncodingInformation;
}
void Trackable::setTrackableEncodingInformation(TrackableEncodingInformationStructure const& value)
{
    m_TrackableEncodingInformation = value;
}
std::string Trackable::getTrackablePayload() const
{
    return m_TrackablePayload;
}
void Trackable::setTrackablePayload(std::string const& value)
{
    m_TrackablePayload = value;
}
std::string Trackable::getUnitSystem() const
{
    return m_UnitSystem;
}
void Trackable::setUnitSystem(std::string const& value)
{
    m_UnitSystem = value;
}
std::vector<double> Trackable::getTrackableDimension() const
{
    return m_TrackableDimension;
}
void Trackable::setTrackableDimension(std::vector<double> const value)
{
    m_TrackableDimension = value;
}
std::map<std::string, std::string> Trackable::getKeyvalueTagList() const
{
    return m_KeyvalueTagList;
}
void Trackable::setKeyvalueTagList(std::map<std::string, std::string> const& value)
{
    m_KeyvalueTagList = value;
}


} // namespace org::openapitools::server::model

